#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/inotify.h>
#include <limits.h>
 
#define MAX_EVENTS 1024 /*Max. number of events to process at one go*/
#define LEN_NAME 16 /*Assuming that the length of the filename won't exceed 16 bytes*/
#define EVENT_SIZE  ( sizeof (struct inotify_event) ) /*size of one event*/
#define BUF_LEN     ( MAX_EVENTS * ( EVENT_SIZE + LEN_NAME )) /*buffer to store the data of events*/

char* substr(const char *src, int m, int n)
{
  int len = n - m;
  char *dest = (char*)malloc(sizeof(char) * (len + 1));
  strncpy(dest, (src + m), len);
  return dest;
}



int main( int argc, char **argv ) 
{
  int length, i = 0, wd, n;
  int fd;
  char buffer[BUF_LEN];
  char tmpBuffer1[350];
  char *filename;
  char *destdir;
  /*int system (char *s); */
 
  /* Initialize Inotify*/
  fd = inotify_init();
  if ( fd < 0 ) {
    perror( "Couldn't initialize inotify");
  }
 
  /* add watch to starting directory */
  wd = inotify_add_watch(fd, argv[1], IN_CREATE); 
 
  if (wd == -1)
    {
      printf("Couldn't add watch to %s\n",argv[1]);
    }
  else
    {
      printf("Watching:: %s\n",argv[1]);

  //    char* token = strtok(argv[1],"/");
  //    char* goes = "goes";
  //    while ( token != NULL ) {
  //      printf(" %s\n",token);
  //      token = strtok(NULL,"/");

  //      printf("%s", starts_with(token, goes))
  //      if(strncmp(goes, token, strlen(goes)) == 0) 
  //       {
  //         printf(" %s\n",token);
  //         break;
  //       }
  //    }

    }
 
  /* do it forever*/
  while(1)
    {
      i = 0;
      length = read( fd, buffer, BUF_LEN );  
 
      if ( length < 0 ) {
        perror( "read" );
      }  
 
      while ( i < length ) {
        struct inotify_event *event = ( struct inotify_event * ) &buffer[ i ];
        if ( event->len ) {
          if ( event->mask & IN_CREATE) {
            if (event->mask & IN_ISDIR) {
              printf( "The directory %s was written.\n", event->name );
	    }
            else {
              printf( "The file %s was written with WD %d\n", event->name, event->wd );    
              filename = event->name;
              destdir = argv[2];

              n = sprintf (tmpBuffer1,"cp %s/%s %s", argv[1], filename, destdir );
	      int rc1 = system (tmpBuffer1);

	    } 
          }
          i += EVENT_SIZE + event->len;
        }
      }
    }
 
  /* Clean up*/
  inotify_rm_watch( fd, wd );
  close( fd );
   
  return 0;
}
