from keras.models import Model, save_model, load_model
from lightningcast import keras_metrics

LIST_OF_METRIC_FUNCTIONS = [
    keras_metrics.accuracy,
    keras_metrics.binary_accuracy,
    keras_metrics.binary_csi,
    keras_metrics.binary_frequency_bias,
    keras_metrics.binary_pod,
    keras_metrics.binary_pofd,
    keras_metrics.binary_peirce_score,
    keras_metrics.binary_success_ratio,
    keras_metrics.binary_focn,
]
METRIC_FUNCTION_DICT = {
    "accuracy": keras_metrics.accuracy,
    "binary_accuracy": keras_metrics.binary_accuracy,
    "binary_csi": keras_metrics.binary_csi,
    "binary_frequency_bias": keras_metrics.binary_frequency_bias,
    "binary_pod": keras_metrics.binary_pod,
    "binary_pofd": keras_metrics.binary_pofd,
    "binary_peirce_score": keras_metrics.binary_peirce_score,
    "binary_success_ratio": keras_metrics.binary_success_ratio,
    "binary_focn": keras_metrics.binary_focn,
}
import sys

model = load_model(sys.argv[1], custom_objects=METRIC_FUNCTION_DICT)
print(model.summary())
