def sat_config():

    sat_info = {}
    sat_info[
        "stride"
    ] = 4  # The number of pixels we want to subsample the computed probs, in effect smoothing the end product
    sat_info[
        "max_focal_plane_temp_threshold"
    ] = 101  # Generally used only for GOES-17 loop-heat-pipe issue
    sat_info[
        "bad_data_fraction_threshold"
    ] = 0.05  # fraction of bad data allowed before entire blocks get flagged
    sat_info["qc_hs"] = 25  # half-size (at 2km res) for QCing purposes

    sat_info[
        "production_site"
    ] = "CIMSS"  # change to 'NCCF' for compliant filenames and metadata
    if sat_info["production_site"] == "NCCF":
        sat_info["time_patt"] = "%Y-%m-%dT%H:%M:%SZ"
        sat_info[
            "institution"
        ] = "DOC/NOAA/NESDIS/OSPO > Office of Satellite and Product Operations, NESDIS, NOAA, U.S. Department of Commerce."
        sat_info[
            "production_environment"
        ] = "dev"  # change to 'operations' when appropriate
    else:
        sat_info[
            "time_patt"
        ] = "%Y%m%d-%H%M%S UTC"  # We use this time patt currently b/c the AWIPS resource uses it --JC 11/2023
        sat_info["institution"] = "University of Wisconsin -- Madison"
        sat_info["production_environment"] = "dev"

    return sat_info
